﻿Public Class frmFuel

    Dim tempLastPosition As Point
    Dim tempPreLastPosition As Point
    Dim tempStartPosition As Point
    Public tempMouseDown As Boolean = False

    Private Sub pctDraw_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles pctDraw.GotFocus
        NeedRefresh = True
    End Sub

    Private Sub pctDraw_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles pctDraw.LostFocus
        Speed = 0
        NeedRefresh = False
    End Sub

    Private Sub pctDraw_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pctDraw.MouseDown
        Dim PositionCorrection As Integer = (-CurrentLocation / (MenuItemCount - 1)) * (Math.Max(MenuDrawSize.Width, (IconSize.Width + 1) * (MenuItemCount)) - (MenuDrawSize.Width))
        Dim TempLocation As MenuLoc = Int((e.X - PositionCorrection) / (Math.Max(MenuDrawSize.Width / (MenuItemCount), IconSize.Width + 1)))
        tempMouseDown = True
        If e.Y > (InnerDrawSize.Height) Then
            If Not TempLocation = CurrentLocation Then
                ChangeLocation(TempLocation)
                MenuSelectNoMove = True
                Call DrawMenuScroll()
            Else
                MenuSelectNoMove = False
            End If
        End If

        'SelectedItem is easy to get when every Object has the same height with this formular
        SelectedItem = Int(((e.Y - CurrentPosition(CurrentLocation).Y)) / ObjectHeight(CurrentLocation))
        'Set Mouse start position
        tempStartPosition.X = e.X
        tempStartPosition.Y = e.Y
        'Reset Position
        tempLastPosition.X = -1
        tempLastPosition.Y = -1
        'System.Environment.TickCount is the time in milliseconds since the System is started
        'It starts to count at Int32.MinValue(-2,147,483,648) and stops at Int32.MaxValue(2,147,483,647)
        'If it is at Int32.MaxValue after 49.8 days it will start at Int32.MinValue again.
    End Sub

    Private Sub pctDraw_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pctDraw.MouseMove
        If tempMouseDown = True Then
            tempPreLastPosition.Y = tempLastPosition.Y
            tempPosTime(0) = tempPosTime(1)
            tempPosTime(1) = System.Environment.TickCount
            If tempStartPosition.Y > (InnerDrawSize.Height) Then
                If MenuSelectNoMove = False Then ChangeLocation(Int((e.X) / (MenuDrawSize.Width / (MenuItemCount))))
                'CurrentLocation = Int((e.X) / (Math.Max(MenuDrawSize.Width / (MenuItemCount), IconSize.Width + 1)))
                If Not LastLocation = CurrentLocation Then
                    Call DrawMenuScroll()
                End If
                LastLocation = CurrentLocation
            Else
                If tempLastPosition.X = -1 And tempLastPosition.Y = -1 Then
                    tempLastPosition.X = e.X
                    tempLastPosition.Y = e.Y
                Else
                    CurrentPosition(CurrentLocation).X = CurrentPosition(CurrentLocation).X + e.X - tempLastPosition.X
                    CurrentPosition(CurrentLocation).Y = Math.Max(CurrentPosition(CurrentLocation).Y + e.Y - tempLastPosition.Y, -(ItemMax(CurrentLocation) + 1) * ObjectHeight(CurrentLocation) + InnerDrawSize.Height)
                    If CurrentPosition(CurrentLocation).X > 0 Then CurrentPosition(CurrentLocation).X = 0
                    If CurrentPosition(CurrentLocation).Y > 0 Then CurrentPosition(CurrentLocation).Y = 0
                    tempLastPosition.X = e.X
                    tempLastPosition.Y = e.Y
                End If
                NeedRedraw = True
            End If
        End If
    End Sub

    Private Sub pctDraw_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pctDraw.MouseUp
        GetSpeed(tempPreLastPosition.Y, tempLastPosition.Y)
        tempLastSpeedTime = System.Environment.TickCount
        Dim DoubleClickTime As Long = Date.Now.Ticks - LastClickedTime
        Dim MaxDoubleTime As Long = 10000 * Config(MyConfig.TapTime)
        Dim tempHorizontal As Byte
        'A item will be clicked when between mouse down and mouse up the user moved the cursor less then 10 pixels
        If (Math.Abs(tempStartPosition.X - e.X) <= 10 * Config(MyConfig.ScreenMultiplicator) And Math.Abs(tempStartPosition.Y - e.Y) <= 10 * Config(MyConfig.ScreenMultiplicator)) And SelectedItem <= ItemMax(CurrentLocation) And SelectedItem >= 0 And e.Y < (InnerDrawSize.Height) Then
            If SelectedItem = LastClickedItem And (DoubleClickTime <= MaxDoubleTime) Then
                If CurrentLocation = MenuLoc.Stats Then
                    'If MsgBox("Do you want to export the data into the AppDir (export.csv)", MsgBoxStyle.YesNo, "Export") = MsgBoxResult.Yes Then
                    '    ExportCSV()
                    'End If
                    If MsgBox("Refresh data (especially for x left data)", MsgBoxStyle.YesNo, "Refresh") = MsgBoxResult.Yes Then
                        SelectStatData(FuelList.Length)
                        Call PreDrawStats()
                        NeedRedraw = True
                    End If

                ElseIf CurrentLocation = MenuLoc.Graph Then

                ElseIf CurrentLocation = MenuLoc.All Then
                    If SelectedItem > 0 And SelectedItem <= OverViewItemCount And SelectedItem + OverViewPage * OverViewItemCount <= FuelList.Length Then
                        If MsgBox("Do you really want to delete number " & (SelectedItem + OverViewPage * OverViewItemCount) & "?", MsgBoxStyle.YesNo, "Delete") = MsgBoxResult.Yes Then
                            Call DeleteFuelData(FuelList(SelectedItem + OverViewPage * OverViewItemCount - 1).ID)
                            'MsgBox(SelectedItem & " Selected")
                            NeedRedraw = True
                        End If
                    End If
            ElseIf CurrentLocation = MenuLoc.Add Then
                    If SelectedItem = 3 Then
                        If Config(MyConfig.DistanceAddType) = "total" And GlueNumberAdd(0) * TripFix <= Stats.All.DistanceState Then
                            MsgBox("It is not allowed to enter a smaller or equal odometer value than in the previous fill (Only in ""Total""-mode)", MsgBoxStyle.Critical, "Error")
                        Else
                            If FuelList.Count > 0 Then
                                If AddTimePrint.Subtract(DateTime.Parse(FuelList(0).TimePrint)).TotalMinutes <= 0 Then
                                    MsgBox("It is not allowed to enter a smaller or equal datetime value than in the previous fill", MsgBoxStyle.Critical, "Error")
                                    GoTo OffCreate
                                End If
                            End If
                            If MsgBox("Do you really want to create a new dataset?", MsgBoxStyle.YesNo, "Create new dataset") = MsgBoxResult.Yes Then
                                Dim CustomDate As String = Format(AddTimePrint, "yyyy-MM-dd HH:mm")
                                If AddFuelData(Math.Round(GlueNumberAdd(0), 2), Math.Round(GlueNumberAdd(1), 2), Math.Round(GlueNumberAdd(1) * GlueNumberAdd(2), 2), Math.Round(GlueNumberAdd(2), 3), False, CustomDate) = True Then
                                    Call ChangeLocation(MenuLoc.All)
                                    CurrentPosition(MenuLoc.All).Y = 0
                                Else
                                    MsgBox("Please check your entered data! Beware that all fields must be greater than 0!", MsgBoxStyle.Critical, "Error")
                                End If
                                NeedRedraw = True
                            End If
OffCreate:
                        End If
                    ElseIf SelectedItem = 4 Then
                        Dim Year As String = AddTimePrint.Year
                        Dim Month As String = AddTimePrint.Month
                        Dim Day As String = AddTimePrint.Day
                        Dim Hour As String = AddTimePrint.Hour
                        Dim Minute As String = AddTimePrint.Minute

                        Do
                            Year = InputBox("Enter a year", "Custom Date", AddTimePrint.Year)
                        Loop Until (ValidDate(Year, Month, Day, Hour, Minute))
                        Do
                            Month = InputBox("Enter a month", "Custom Date", AddTimePrint.Month)
                        Loop Until (ValidDate(Year, Month, Day, Hour, Minute))
                        Do
                            Day = InputBox("Enter a day", "Custom Date", AddTimePrint.Day)
                        Loop Until (ValidDate(Year, Month, Day, Hour, Minute))
                        Do
                            Hour = InputBox("Enter a hour", "Custom Date", AddTimePrint.Hour)
                        Loop Until (ValidDate(Year, Month, Day, Hour, Minute))
                        Do
                            Minute = InputBox("Enter the mintues", "Custom Date", AddTimePrint.Minute)
                        Loop Until (ValidDate(Year, Month, Day, Hour, Minute))

                        AddTimePrint = DateTime.Parse(Year + "-" + Month + "-" + Day + " " + Hour + ":" + Minute)
                        Call PreDrawAdd()
                        NeedRedraw = True
                    End If
                        ElseIf CurrentLocation = MenuLoc.Config Then
                            If SelectedItem < ItemMax(MenuLoc.Config) - 1 And e.X > 48 And e.X < InnerDrawSize.Width - 48 Then
                                If ConfigShow(SelectedItem, ConfigSelected(SelectedItem), ConfigType.Value) = "custom" Then
                                    ConfigCustom(SelectedItem) = InputBox("Please enter your custom """ & ConfigName(SelectedItem) & """", "Custom Config", ConfigCustom(SelectedItem))
                                    Call PreDrawConfig()
                                    NeedRedraw = True
                                End If
                            ElseIf SelectedItem = ItemMax(MenuLoc.Config) - 1 Then
                                If MsgBox("Do you want to save your changes?" & vbNewLine & "", MsgBoxStyle.YesNo, "Save?") = MsgBoxResult.Yes Then
                                    Call ConfigMenuSave()
                                End If
                            ElseIf SelectedItem = ItemMax(MenuLoc.Config) Then
                                If e.X <= InnerDrawSize.Width / 2 Then
                                    If MsgBox("Do you want to export(and backup) your Fuel Blaster Data to a CSV?" & vbNewLine & "", MsgBoxStyle.YesNo, "Export?") = MsgBoxResult.Yes Then
                                        Call ExportCSV()
                                        MsgBox("Exported to:" & vbNewLine & AppPath & "\export.csv", MsgBoxStyle.Exclamation, "Exported")
                                    End If
                                Else
                                    If MsgBox("Do you want to import your Fuel Blaster Data from the ""export.csv"" in the SciLor's Fuel Blaster directory?" & vbNewLine & "", MsgBoxStyle.YesNo, "Import?") = MsgBoxResult.Yes Then
                                        Call LoadCSV()
                                    End If
                                End If
                            End If
                        ElseIf CurrentLocation = MenuLoc.About Then
                        ElseIf CurrentLocation = MenuLoc.EndMenu Then
                            Application.Exit()
                        End If
                        LastClickedItem = -1
                    Else
                        LastClickedItem = SelectedItem
                    End If
JumpOver:
                    If CurrentLocation = MenuLoc.All Then
                        If SelectedItem = 0 Then
                            If OverViewPage = 0 Then

                            Else
                                OverViewPage -= 1
                                If GetOverViewFix() = 0 Then
                                    ItemMax(CurrentLocation) = OverViewItemCount + OverViewBufferCount - 1
                                Else
                                    ItemMax(CurrentLocation) = FuelList.Length - OverViewPage * OverViewItemCount + (OverViewBufferCount - 1) - 1
                                End If

                                Call PreDrawAll()
                                NeedRedraw = True
                                CurrentPosition(CurrentLocation).Y = -(ItemMax(CurrentLocation) + 1) * ObjectHeight(CurrentLocation) + InnerDrawSize.Height
                            End If
                        ElseIf SelectedItem = OverViewItemCount + 1 Then
                            If (OverViewPage + 1) * OverViewItemCount < FuelList.Length Then
                                OverViewPage += 1
                                If GetOverViewFix() = 0 Then
                                    ItemMax(CurrentLocation) = OverViewItemCount + OverViewBufferCount - 1
                                Else
                                    ItemMax(CurrentLocation) = FuelList.Length - OverViewPage * OverViewItemCount + (OverViewBufferCount - 1) - 1
                                End If

                                Call PreDrawAll()
                                NeedRedraw = True
                                CurrentPosition(CurrentLocation).Y = 0
                            End If
                        End If

                    ElseIf CurrentLocation = MenuLoc.Add Then
                        tempHorizontal = Math.Max(0, Int((e.X - BlackDrawingPen.Width * 2 * Config(MyConfig.ScreenMultiplicator)) / ArrowCountPerLine))
                        If e.Y - CurrentPosition(MenuLoc.Add).Y < ObjectHeight(MenuLoc.Add) * 3 And e.X < BlackDrawingPen.Width * 2 * Config(MyConfig.ScreenMultiplicator) + 7 * ArrowCountPerLine Then
                            For I = 0 To 2
                                If e.Y - CurrentPosition(MenuLoc.Add).Y < (I + 1) * ObjectHeight(MenuLoc.Add) And e.Y - CurrentPosition(MenuLoc.Add).Y > I * ObjectHeight(MenuLoc.Add) + FontLineHeight Then
                                    tempHorizontal = Math.Max(0, Int((e.X - BlackDrawingPen.Width * 2 * Config(MyConfig.ScreenMultiplicator)) / ArrowCountPerLine))
                                    If e.Y - CurrentPosition(MenuLoc.Add).Y < (ObjectHeight(MenuLoc.Add) + FontLineHeight) / 2 + ObjectHeight(MenuLoc.Add) * I Then
                                        Call AddRemoveAdd(1, I, tempHorizontal)
                                    Else
                                        Call AddRemoveAdd(-1, I, tempHorizontal)
                                    End If
                                    Call PreDrawAdd()
                                    NeedRedraw = True
                                    Exit For
                                End If
                            Next
                        ElseIf tempHorizontal = 7 And SelectedItem <= 2 And e.X >= BlackDrawingPen.Width * 2 * Config(MyConfig.ScreenMultiplicator) + 7 * ArrowCountPerLine Then
                            For I = 0 To 2
                                If e.Y - CurrentPosition(MenuLoc.Add).Y < (I + 1) * ObjectHeight(MenuLoc.Add) Then
                                    Dim myTempNumber As Single
                                    Try
                                        If I = 0 Then 'Distance
                                            myTempNumber = InputBox("Please enter the distance in " & Config(MyConfig.MetricsUnit), "Number Input", GlueNumber(I) * TripFix)
                                            Call SplitAddNumber(I, myTempNumber / TripFix)
                                        ElseIf I = 1 Then 'Fuel
                                            myTempNumber = InputBox("Please enter amount you refilled in " & Config(MyConfig.FuelAmountUnit), "Number Input", GlueNumber(I))
                                            Call SplitAddNumber(I, myTempNumber)
                                        Else 'If I = 2 Then 'Price 
                                            myTempNumber = InputBox("Please enter price p. " & Config(MyConfig.CurrencyUnit), "Number Input", GlueNumber(I))
                                            Call SplitAddNumber(I, myTempNumber)
                                        End If
                                    Catch
                                    End Try
                                    Call PreDrawAdd()
                                    NeedRedraw = True
                                    Exit For
                                End If
                            Next
                        End If
                    ElseIf CurrentLocation = MenuLoc.Config Then
                        If SelectedItem < ItemMax(MenuLoc.Config) Then
                            If e.X < 48 * Config(MyConfig.ScreenMultiplicator) Then
                                AddRemoveConfig(-1, SelectedItem)
                            ElseIf e.X > InnerDrawSize.Width - 48 * Config(MyConfig.ScreenMultiplicator) Then
                                AddRemoveConfig(1, SelectedItem)
                            End If
                            Call PreDrawConfig()
                            NeedRedraw = True
                        End If
                    ElseIf CurrentLocation = MenuLoc.Graph Then
                        If e.X > GraphDrawingSize.Width Or e.Y > GraphDrawingSize.Height Then
                            Dim tempSelectedX As Byte = Int(e.X / ButtonBottomItemWidth)
                            Dim tempSelectedY As Byte = Int(e.Y / ButtonRightItemHeight)
                            Dim currentSelected As String = ""

                            If e.Y > GraphDrawingSize.Height Then
                                If tempSelectedX > 4 Then
                                    currentSelected = "y"
                                Else
                                    currentSelected = "x"
                                End If
                            ElseIf e.X > GraphDrawingSize.Width Then
                                If tempSelectedY > 4 Then
                                    currentSelected = "x"
                                Else
                                    currentSelected = "y"
                                End If
                            End If

                            If currentSelected = "x" Then
                                ShowGraph(tempSelectedX) = Not ShowGraph(tempSelectedX)
                            ElseIf currentSelected = "y" Then
                                MaxGraphItems = VisibleCountArray(tempSelectedY, ConfigType.Value)
                            End If
                            Call PreDrawGraphs()
                            NeedRedraw = True
                        End If
                    ElseIf CurrentLocation = MenuLoc.About Then
                        If tmrDirectX.Enabled = True Then
                            tmrDirectX.Enabled = False
                        Else
                            tmrDirectX.Enabled = True
                        End If
                        Call DrawAboutPause()
                    End If

                    Speed = 0
        ElseIf e.Y > (InnerDrawSize.Height) Then
            If CurrentLocation = MenuLoc.Add Then
                Call PreDrawAdd(True)
            ElseIf CurrentLocation = MenuLoc.Config Then
                Call LoadConfig()
                Call PreDrawConfig()
                NeedRedraw = True
            End If
        End If

Abort:

        tempMouseDown = False
        MenuSelectNoMove = False
        NeedRefresh = True

        If DoubleClickTime <= MaxDoubleTime And Not LastClickedTime = 0 Then
            LastClickedTime = 0
        Else
            LastClickedTime = Date.Now.Ticks
        End If
    End Sub

    Private Function ValidDate(ByVal Year As String, ByVal Month As String, ByVal Day As String, ByVal Hour As String, ByVal Minute As String) As Boolean
        Try
            DateTime.Parse(Year + "-" + Month + "-" + Day + " " + Hour + ":" + Minute)
        Catch ex As Exception
            MsgBox("Invalid Date, try again", MsgBoxStyle.Critical, "Error")
            Return False
        End Try
        Return True
    End Function


    Private Sub pctDraw_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles pctDraw.Paint
        'Only Refresh if the backbuffer isnt empty and if there is a new image
        If Not BackBufferDrawBitMap Is Nothing And NeedRefresh = True Then
            e.Graphics.DrawImage(BackBufferDrawBitMap, 0, 0)
            NeedRefresh = False
            FrapsCount += 1
        End If
    End Sub

    Private Sub tmrDraw_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrDraw.Tick
        If tempMouseDown = False Then KeepMoving()
        tempLastSpeedTime = System.Environment.TickCount

        'Draw Objects and then Refresh Screen
        If NeedRedraw = True Then 'Or NeedRedraw = False Then
            Call DrawToSurface()

            'pctDraw.Image = BackBufferDrawBitMap
            NeedRedraw = False
            NeedRefresh = True
            Me.pctDraw.Refresh()
        End If
    End Sub

    Private Sub frmFuel_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.GotFocus
        NeedRefresh = True
    End Sub

    Private Sub frmMain_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Call StartUp()
        'Dim T1 As New Thread(AddressOf StartUp)
        'T1.Priority = ThreadPriority.BelowNormal
        'T1.Start()
    End Sub

    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Application.Exit()
    End Sub

    Public Sub pctDraw_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles pctDraw.Resize
        InnerDrawSize.Width = pctDraw.Width
        MenuDrawSize.Width = pctDraw.Width
        ArrowCountPerLine = InnerDrawSize.Width / 8

        InnerDrawSize.Height = pctDraw.Height - MenuDrawSize.Height - 1
        ArrowCountPerLine = InnerDrawSize.Width / 8

        ObjectHeight(MenuLoc.Graph) = InnerDrawSize.Height
        ObjectHeight(MenuLoc.About) = InnerDrawSize.Height
        ObjectHeight(MenuLoc.EndMenu) = InnerDrawSize.Height

        If isStartUp = True Then
            Call PreDraw()
        End If

        If CurrentLocation = MenuLoc.About Then
            Call tmrDirectX_Tick(sender, e)
            Call DrawAboutPause()
        End If

        NeedRedraw = True
    End Sub

    Public Sub ChangeLocation(ByVal NewLocation As MenuLoc)
        If CurrentLocation = MenuLoc.About Then
            tmrDirectX.Enabled = False
        End If

        CurrentPosition(NewLocation).Y = 0
        If NewLocation = MenuLoc.All Then
        ElseIf NewLocation = MenuLoc.About Then
            AboutText = AboutTextComplete
            CurrentAboutPosition = 1
            Call tmrDirectX_Tick(New Object, New System.EventArgs)
            tmrDirectX.Enabled = True
        ElseIf NewLocation = MenuLoc.Add Then
            If Not Config(MyConfig.DistanceAddType) = "total" Then
                Call SplitAddNumber(0, Stats.Average.KiloMeters)
            Else
                Call SplitAddNumber(0, (Stats.Average.KiloMeters + Stats.All.DistanceState) / TripFix)
            End If

            Call SplitAddNumber(1, Stats.Average.FuelAmount)
            Call SplitAddNumber(2, Stats.Average.PricePerLiter)
            AddNumbers(2, 6) = 9
            AddTimePrint = DateTime.Now
        End If

        CurrentLocation = NewLocation
    End Sub

    Private Sub AddRemoveAdd(ByVal NumberCrease As Short, ByVal Vertical As Byte, ByVal Horizontal As Byte)
        If AddNumbers(Vertical, Horizontal) + NumberCrease > 9 Then
            AddNumbers(Vertical, Horizontal) = 0
        ElseIf AddNumbers(Vertical, Horizontal) + NumberCrease < 0 Then
            AddNumbers(Vertical, Horizontal) = 9
        Else
            AddNumbers(Vertical, Horizontal) += NumberCrease
        End If
    End Sub

    Private Sub AddRemoveConfig(ByVal NumberCrease As Short, ByVal ConfigID As Byte)
        If ConfigSelected(ConfigID) + NumberCrease >= 0 And ConfigSelected(ConfigID) + NumberCrease <= ConfigMax(ConfigID) Then
            ConfigSelected(ConfigID) += NumberCrease
        End If
    End Sub

    Private Sub SplitAddNumber(ByVal Vertical As Byte, ByVal Number As Single)
        '0{0, 5}, 1{1, 5}, 2{2, 6}
        Dim tempNumber As String
        tempNumber = FormatNumber(Number, 3, TriState.True, TriState.False, TriState.False).PadLeft(8, "0")
        For I = 0 To 3
            AddNumbers(Vertical, I) = tempNumber.Substring(I, 1)
        Next
        For I = Len(tempNumber) - 3 To Len(tempNumber) - 1
            AddNumbers(Vertical, I - (Len(tempNumber) - 3) + 4) = tempNumber.Substring(I, 1)
        Next
    End Sub

    Private Function GlueNumberAdd(ByVal Vertical As Byte) As Double
        Dim tempNumber As Double
        For I = 0 To NumberSpan(Vertical, 0) - 1
            AddNumbers(Vertical, I) = 0
        Next
        For I = NumberSpan(Vertical, 1) + 1 To 6
            AddNumbers(Vertical, I) = 0
        Next
        For I = 0 To 6
            tempNumber += AddNumbers(Vertical, I) * 10 ^ ((6 - I) - 3)
        Next
        GlueNumberAdd = tempNumber
    End Function

    Private Function GlueNumber(ByVal Vertical As Byte) As String
        Dim tempNumber As Single
        For I = 0 To NumberSpan(Vertical, 0) - 1
            AddNumbers(Vertical, I) = 0
        Next
        For I = NumberSpan(Vertical, 1) + 1 To 6
            AddNumbers(Vertical, I) = 0
        Next
        For I = 0 To 6
            tempNumber += AddNumbers(Vertical, I) * 10 ^ ((6 - I) - 3)
        Next
        GlueNumber = FormatNumber(tempNumber, NumberSpan(Vertical, 1) - 3, TriState.True, TriState.False, TriState.False)
    End Function
End Class
