﻿Imports System.Data.SqlServerCe
Imports System.Data.SqlTypes

Module mdlSQL
    Private Function ReplaceInfinity(ByVal Number As Double) As Double
        If Double.IsInfinity(Number) Or Double.IsNaN(Number) Then
            Return 0
        Else
            Return Number
        End If
    End Function


    Private Sub AddFuelStats(ByVal KiloMeters As Double, ByVal FuelAmount As Double, ByVal PriceAmount As Double, ByVal PricePerLiter As Double)
        Dim TempStats As FuelStats
        Dim SQLcon As SqlCeConnection = Nothing
        SQLcon = New SqlCeConnection("Data Source=" & DataPath)

        Dim SQLString As String = "SELECT * FROM Stats"
        SQLcon.Open()
        Dim SQLQuery As SqlCeCommand = New SqlCeCommand(SQLString, SQLcon)
        Dim SQLDataReader As SqlCeDataReader = SQLQuery.ExecuteReader
        SQLDataReader.Read()
        TempStats.All.KiloMeters = SQLDataReader.Item("kilometers")
        TempStats.All.FuelAmount = SQLDataReader.Item("fuelamount")
        TempStats.All.PriceAmount = SQLDataReader.Item("priceamount")

        SQLString = "UPDATE Stats SET kilometers = @kilometers, fuelamount = @fuelamount, priceamount = @priceamount"
        SQLQuery = New SqlCeCommand(SQLString, SQLcon)
        SQLQuery.Parameters.AddWithValue("@kilometers", TempStats.All.KiloMeters + KiloMeters)
        SQLQuery.Parameters.AddWithValue("@fuelamount", TempStats.All.FuelAmount + FuelAmount)
        SQLQuery.Parameters.AddWithValue("@priceamount", TempStats.All.PriceAmount + PriceAmount)
        SQLQuery.ExecuteNonQuery()

        SQLcon.Close()
    End Sub

    Private Sub RemoveFuelStats(ByVal ID As Integer)
        Dim TempStats As FuelStats
        Dim SQLcon As SqlCeConnection = Nothing
        SQLcon = New SqlCeConnection("Data Source=" & DataPath)

        Dim SQLString As String = "SELECT * FROM Stats"
        SQLcon.Open()
        Dim SQLQuery As SqlCeCommand = New SqlCeCommand(SQLString, SQLcon)
        Dim SQLDataReader As SqlCeDataReader = SQLQuery.ExecuteReader
        SQLDataReader.Read()
        TempStats.All.KiloMeters = SQLDataReader.Item("kilometers")
        TempStats.All.FuelAmount = SQLDataReader.Item("fuelamount")
        TempStats.All.PriceAmount = SQLDataReader.Item("priceamount")
        SQLDataReader.Close()

        SQLString = "SELECT kilometers, fuelamount, priceamount FROM FuelData WHERE id = @id"
        SQLQuery = New SqlCeCommand(SQLString, SQLcon)
        SQLQuery.Parameters.AddWithValue("@id", ID)
        SQLDataReader = SQLQuery.ExecuteReader
        SQLDataReader.Read()
        TempStats.All.KiloMeters -= SQLDataReader.Item("kilometers")
        TempStats.All.FuelAmount -= SQLDataReader.Item("fuelamount")
        TempStats.All.PriceAmount -= SQLDataReader.Item("priceamount")

        SQLString = "UPDATE Stats SET kilometers = @kilometers, fuelamount = @fuelamount, priceamount = @priceamount"
        SQLQuery = New SqlCeCommand(SQLString, SQLcon)
        SQLQuery.Parameters.AddWithValue("@kilometers", TempStats.All.KiloMeters)
        SQLQuery.Parameters.AddWithValue("@fuelamount", TempStats.All.FuelAmount)
        SQLQuery.Parameters.AddWithValue("@priceamount", TempStats.All.PriceAmount)
        SQLQuery.ExecuteNonQuery()

        SQLcon.Close()
    End Sub

    Private Sub ClearFuelStats()
        Dim SQLcon As SqlCeConnection = Nothing
        SQLcon = New SqlCeConnection("Data Source=" & DataPath)

        Dim SQLString As String = "UPDATE Stats SET kilometers = @kilometers, fuelamount = @fuelamount, priceamount = @priceamount"
        SQLcon.Open()
        Dim SQLQuery As SqlCeCommand = New SqlCeCommand(SQLString, SQLcon)
        SQLQuery = New SqlCeCommand(SQLString, SQLcon)
        SQLQuery.Parameters.AddWithValue("@kilometers", 0)
        SQLQuery.Parameters.AddWithValue("@fuelamount", 0)
        SQLQuery.Parameters.AddWithValue("@priceamount", 0)
        SQLQuery.ExecuteNonQuery()

        SQLcon.Close()
    End Sub

    Public Function AddFuelData(ByVal KiloMeters As Double, ByVal FuelAmount As Double, ByVal PriceAmount As Double, ByVal PricePerLiter As Double, Optional ByVal Import As Boolean = False, Optional ByVal CustomDate As String = "") As Boolean


        Dim TimePrint As String = Format(DateTime.Now, "yyyy-MM-dd HH:mm")
        Dim SQLcon As SqlCeConnection = Nothing
        SQLcon = New SqlCeConnection("Data Source=" & DataPath)
        Dim SQLString As String = "INSERT INTO FuelData " & _
                                  "(kilometers, fuelamount, priceamount, consumptionper100, priceperliter, timeprint)" & _
                                  " VALUES " & _
                                  "(@kilometers, @fuelamount, @priceamount, @consumptionper100, @priceperliter, @timeprint)"
        SQLcon.Open()
        If Config(MyConfig.DistanceAddType) = "total" And Import = False Then
            KiloMeters *= TripFix
            KiloMeters -= Stats.All.DistanceState
        End If
        'MsgBox(KiloMeters & vbNewLine & FuelAmount & vbNewLine & PriceAmount & vbNewLine & PricePerLiter)
        If Not CustomDate = "" Then
            TimePrint = Format(DateTime.Parse(CustomDate), "yyyy-MM-dd HH:mm")
        End If

        If KiloMeters <= 0 Or FuelAmount <= 0 Or PriceAmount <= 0 Then
            Return False
        End If

        Dim SQLQuery As SqlCeCommand = New SqlCeCommand(SQLString, SQLcon)
        SQLQuery.Parameters.AddWithValue("@kilometers", KiloMeters)
        SQLQuery.Parameters.AddWithValue("@fuelamount", FuelAmount)
        SQLQuery.Parameters.AddWithValue("@priceamount", PriceAmount)
        SQLQuery.Parameters.AddWithValue("@priceperliter", PricePerLiter)
        SQLQuery.Parameters.AddWithValue("@consumptionper100", Math.Round(FuelAmount / KiloMeters * 100, 2))
        SQLQuery.Parameters.AddWithValue("@timeprint", TimePrint)

        SQLQuery.ExecuteNonQuery()

        SQLcon.Close()

        OverViewPage = 0
        Call AddFuelStats(KiloMeters, FuelAmount, PriceAmount, PricePerLiter)
        Call SelectFuelData()
        Return True
    End Function

    Public Sub EditFuelData(ByVal KiloMeters As Double, ByVal FuelAmount As Double, ByVal PriceAmount As Double, ByVal PricePerLiter As Double, ByVal ID As Integer)
        Call RemoveFuelStats(ID)

        Dim TimePrint As String = Format(DateTime.Now, "yyyy-MM-dd HH:mm")
        Dim SQLcon As SqlCeConnection = Nothing
        SQLcon = New SqlCeConnection("Data Source=" & DataPath)
        Dim SQLString As String = "UPDATE FuelData SET kilometers = @kilometers, fuelamount = @fuelamount, priceamount = @priceamount, priceperliter = @priceperliter, consumptionper100 = @consumptionper100, timeprint = @timeprint WHERE id = @id"
        SQLcon.Open()

        If Config(MyConfig.DistanceAddType) = "total" Then
            KiloMeters -= Stats.All.DistanceState
        End If

        Dim SQLQuery As SqlCeCommand = New SqlCeCommand(SQLString, SQLcon)
        SQLQuery.Parameters.AddWithValue("@kilometers", KiloMeters)
        SQLQuery.Parameters.AddWithValue("@fuelamount", FuelAmount)
        SQLQuery.Parameters.AddWithValue("@priceamount", PriceAmount)
        SQLQuery.Parameters.AddWithValue("@priceperliter", PricePerLiter)
        SQLQuery.Parameters.AddWithValue("@consumptionper100", Math.Round(FuelAmount / KiloMeters * 100, 2))
        SQLQuery.Parameters.AddWithValue("@timeprint", TimePrint)
        SQLQuery.Parameters.AddWithValue("@id", ID)
        SQLQuery.ExecuteNonQuery()

        SQLcon.Close()


        Call AddFuelStats(KiloMeters, FuelAmount, PriceAmount, PricePerLiter)
        Call SelectFuelData()
    End Sub

    Public Sub DeleteFuelData(ByVal ID As Integer)
        Call RemoveFuelStats(ID)

        Dim SQLcon As SqlCeConnection = Nothing
        SQLcon = New SqlCeConnection("Data Source=" & DataPath)
        Dim SQLString As String = "DELETE FROM FuelData WHERE id = @id"
        SQLcon.Open()

        Dim SQLQuery As SqlCeCommand = New SqlCeCommand(SQLString, SQLcon)
        SQLQuery.Parameters.AddWithValue("@id", ID)
        SQLQuery.ExecuteNonQuery()

        SQLcon.Close()

        If Int((FuelList.Length - 2) / OverViewItemCount) < OverViewPage Then OverViewPage = Math.Max(OverViewPage - 1, 0)
        Call SelectFuelData()
    End Sub

    Public Sub SelectFuelData()
        Dim SQLcon As SqlCeConnection = Nothing
        SQLcon = New SqlCeConnection("Data Source=" & DataPath)
        Dim SQLString As String = "SELECT * FROM FuelData ORDER BY timeprint DESC"
        Dim SQLRowCountString As String = "SELECT COUNT(*) FROM FuelData"
        SQLcon.Open()

        Dim SQLRowCount As Integer = New SqlCeCommand(SQLRowCountString, SQLcon).ExecuteScalar - 1

        Dim SQLQuery As SqlCeCommand = New SqlCeCommand(SQLString, SQLcon)
        Dim SQLDataReader As SqlCeDataReader = SQLQuery.ExecuteReader

        Dim I As Integer = 0
        ReDim FuelList(SQLRowCount)
        While SQLDataReader.Read()

            FuelList(I).ID = SQLDataReader.Item("id")

            FuelList(I).KiloMeters = SQLDataReader.Item("kilometers")
            FuelList(I).FuelAmount = SQLDataReader.Item("fuelamount")
            FuelList(I).PriceAmount = SQLDataReader.Item("priceamount")
            FuelList(I).PricePerLiter = SQLDataReader.Item("priceperliter")
            FuelList(I).ConsumptionPer100 = SQLDataReader.Item("consumptionper100")
            FuelList(I).MilesPerGallon = Math.Round(1 / (FuelList(I).ConsumptionPer100 / 100), 3)
            FuelList(I).TimePrint = SQLDataReader.Item("timeprint")
            I += 1
        End While

        Stats.All.DistanceState = Config(MyConfig.DistanceStart)
        For J = I - 1 To 0 Step -1
            Stats.All.DistanceState += FuelList(J).KiloMeters
            FuelList(J).DistanceState = Stats.All.DistanceState
        Next

        'ItemMax(MenuLoc.All) = I - 1
        If GetOverViewFix() = 0 Then
            ItemMax(MenuLoc.All) = OverViewItemCount + OverViewBufferCount - 1
        Else
            ItemMax(MenuLoc.All) = FuelList.Length - OverViewPage * OverViewItemCount + (OverViewBufferCount - 1) - 1
        End If

        Stats.MinMax.Min.TimeDiff = Double.MaxValue
        Stats.MinMax.Max.TimeDiff = 0
        For J = 0 To I - 1 - 1
            FuelList(J).TimeDiff = Math.Round(DateTime.Parse(FuelList(J).TimePrint).Subtract(DateTime.Parse(FuelList(J + 1).TimePrint)).TotalHours / 24, 2)
            Stats.MinMax.Min.TimeDiff = Math.Min(Stats.MinMax.Min.TimeDiff, FuelList(J).TimeDiff)
            Stats.MinMax.Max.TimeDiff = Math.Max(Stats.MinMax.Max.TimeDiff, FuelList(J).TimeDiff)
        Next
        If Stats.MinMax.Min.TimeDiff = Double.MaxValue Then Stats.MinMax.Min.TimeDiff = 0

        SQLcon.Close()

        If ItemMax(MenuLoc.All) = 0 Then Call ClearFuelStats()
        Call SelectStatData(I)
        PreDraw()
    End Sub

    Public Sub SelectStatData(ByVal MyCount As Integer)
        Dim SQLcon As SqlCeConnection = Nothing
        SQLcon = New SqlCeConnection("Data Source=" & DataPath)
        Dim SQLString As String = "SELECT * FROM Stats"
        SQLcon.Open()
        Dim SQLQuery As SqlCeCommand = New SqlCeCommand(SQLString, SQLcon)
        Dim SQLDataReader As SqlCeDataReader = SQLQuery.ExecuteReader
        SQLDataReader.Read()
        Stats.All.KiloMeters = SQLDataReader.Item("kilometers")
        Stats.All.KiloMeters = Math.Round(Stats.All.KiloMeters, 0)
        Stats.All.FuelAmount = SQLDataReader.Item("fuelamount")
        Stats.All.FuelAmount = Math.Round(Stats.All.FuelAmount, 0)
        Stats.All.PriceAmount = SQLDataReader.Item("priceamount")
        Stats.All.PriceAmount = Math.Round(Stats.All.PriceAmount, 0)

        Dim TimeTemp(2) As DateTime
        Try
            SQLQuery.CommandText = "SELECT timeprint FROM FuelData ORDER BY timeprint ASC"
            TimeTemp(0) = DateTime.Parse(SQLQuery.ExecuteScalar)
            SQLQuery.CommandText = "SELECT timeprint FROM FuelData ORDER BY timeprint DESC"
            TimeTemp(1) = DateTime.Parse(SQLQuery.ExecuteScalar)
            Stats.All.TimeLength = Math.Round(TimeTemp(1).Subtract(TimeTemp(0)).TotalHours / 24, 2)
        Catch Ex As Exception
            Stats.All.TimeLength = 0
        End Try

        Stats.Average.KiloMeters = Math.Round(ReplaceInfinity(Stats.All.KiloMeters / MyCount), 2)
        Stats.Average.FuelAmount = Math.Round(ReplaceInfinity(Stats.All.FuelAmount / MyCount), 2)
        Stats.Average.PriceAmount = Math.Round(ReplaceInfinity(Stats.All.PriceAmount / MyCount), 2)
        Stats.Average.TimeDiff = Math.Round(ReplaceInfinity(Stats.All.TimeLength / (MyCount - 1)), 2)

        Stats.Average.PricePerLiter = Math.Round(ReplaceInfinity(Stats.All.PriceAmount / Stats.All.FuelAmount), 3)
        Stats.Average.ConsumptionPer100 = Math.Round(ReplaceInfinity(Stats.All.FuelAmount / Stats.All.KiloMeters) * 100, 2)

        Stats.All.TimeLength = Math.Round(Stats.All.TimeLength, 0)

        SQLQuery.CommandText = "SELECT kilometers FROM FuelData ORDER BY kilometers ASC"
        Stats.MinMax.Min.KiloMeters = SQLQuery.ExecuteScalar
        Stats.MinMax.Min.KiloMeters = Math.Round(Stats.MinMax.Min.KiloMeters, 2)
        SQLQuery.CommandText = "SELECT kilometers FROM FuelData ORDER BY kilometers DESC"
        Stats.MinMax.Max.KiloMeters = SQLQuery.ExecuteScalar
        Stats.MinMax.Max.KiloMeters = Math.Round(Stats.MinMax.Max.KiloMeters, 2)

        SQLQuery.CommandText = "SELECT fuelamount FROM FuelData ORDER BY fuelamount ASC"
        Stats.MinMax.Min.FuelAmount = SQLQuery.ExecuteScalar
        Stats.MinMax.Min.FuelAmount = Math.Round(Stats.MinMax.Min.FuelAmount, 2)
        SQLQuery.CommandText = "SELECT fuelamount FROM FuelData ORDER BY fuelamount DESC"
        Stats.MinMax.Max.FuelAmount = SQLQuery.ExecuteScalar
        Stats.MinMax.Max.FuelAmount = Math.Round(Stats.MinMax.Max.FuelAmount, 2)

        SQLQuery.CommandText = "SELECT priceamount FROM FuelData ORDER BY priceamount ASC"
        Stats.MinMax.Min.PriceAmount = SQLQuery.ExecuteScalar
        Stats.MinMax.Min.PriceAmount = Math.Round(Stats.MinMax.Min.PriceAmount, 2)
        SQLQuery.CommandText = "SELECT priceamount FROM FuelData ORDER BY priceamount DESC"
        Stats.MinMax.Max.PriceAmount = SQLQuery.ExecuteScalar
        Stats.MinMax.Max.PriceAmount = Math.Round(Stats.MinMax.Max.PriceAmount, 2)

        SQLQuery.CommandText = "SELECT priceperliter FROM FuelData ORDER BY priceperliter ASC"
        Stats.MinMax.Min.PricePerLiter = SQLQuery.ExecuteScalar
        Stats.MinMax.Min.PricePerLiter = Math.Round(Stats.MinMax.Min.PricePerLiter, 3)
        SQLQuery.CommandText = "SELECT priceperliter FROM FuelData ORDER BY priceperliter DESC"
        Stats.MinMax.Max.PricePerLiter = SQLQuery.ExecuteScalar
        Stats.MinMax.Max.PricePerLiter = Math.Round(Stats.MinMax.Max.PricePerLiter, 3)

        SQLQuery.CommandText = "SELECT consumptionper100 FROM FuelData ORDER BY consumptionper100 ASC"
        Stats.MinMax.Min.ConsumptionPer100 = SQLQuery.ExecuteScalar
        Stats.MinMax.Min.ConsumptionPer100 = Math.Round(Stats.MinMax.Min.ConsumptionPer100, 2)
        SQLQuery.CommandText = "SELECT consumptionper100 FROM FuelData ORDER BY consumptionper100 DESC"
        Stats.MinMax.Max.ConsumptionPer100 = SQLQuery.ExecuteScalar
        Stats.MinMax.Max.ConsumptionPer100 = Math.Round(Stats.MinMax.Max.ConsumptionPer100, 2)

        SQLcon.Close()

        Stats.Average.MilesPerGallon = Math.Round(ReplaceInfinity(1 / (Stats.Average.ConsumptionPer100 / 100)), 3)
        Stats.MinMax.Min.MilesPerGallon = Math.Round(ReplaceInfinity(1 / (Stats.MinMax.Max.ConsumptionPer100 / 100)), 3)
        Stats.MinMax.Max.MilesPerGallon = Math.Round(ReplaceInfinity(1 / (Stats.MinMax.Min.ConsumptionPer100 / 100)), 3)

        Dim DaySpan As Double = Now.Subtract(TimeTemp(1)).TotalHours / 24
        If TimeTemp(1) = TimeTemp(2) Then
            DaySpan = 0
        End If

        Stats.Average.LeftKiloMeters = Math.Round(Stats.Average.KiloMeters - ReplaceInfinity(Stats.Average.KiloMeters / Stats.Average.TimeDiff * DaySpan), 2)
        Stats.Average.LeftFuelAmount = Math.Round(Stats.Average.FuelAmount - ReplaceInfinity(Stats.Average.FuelAmount / Stats.Average.TimeDiff * DaySpan), 2)
        Stats.Average.LeftTimeLength = Math.Round(Stats.Average.TimeDiff - DaySpan, 2)

        Stats.MinMax.Min.LeftKiloMeters = Math.Round(Stats.MinMax.Min.KiloMeters - ReplaceInfinity(Stats.MinMax.Max.KiloMeters / Stats.MinMax.Min.TimeDiff * DaySpan), 2)
        Stats.MinMax.Min.LeftFuelAmount = Math.Round(Stats.MinMax.Min.FuelAmount - ReplaceInfinity(Stats.MinMax.Max.FuelAmount / Stats.MinMax.Min.TimeDiff * DaySpan), 2)
        Stats.MinMax.Min.LeftTimeLength = Math.Round(Stats.MinMax.Min.TimeDiff - DaySpan, 2)
        Stats.MinMax.Max.LeftKiloMeters = Math.Round(Stats.MinMax.Max.KiloMeters - ReplaceInfinity(Stats.MinMax.Min.KiloMeters / Stats.MinMax.Max.TimeDiff * DaySpan), 2)
        Stats.MinMax.Max.LeftFuelAmount = Math.Round(Stats.MinMax.Max.FuelAmount - ReplaceInfinity(Stats.MinMax.Min.FuelAmount / Stats.MinMax.Max.TimeDiff * DaySpan), 2)
        Stats.MinMax.Max.LeftTimeLength = Math.Round(Stats.MinMax.Max.TimeDiff - DaySpan, 2)


        AddStats.KiloMeters = Math.Round(Stats.Average.KiloMeters, 0)
        AddStats.PricePerLiter = Stats.Average.PricePerLiter
        AddStats.FuelAmount = Math.Round(Stats.Average.FuelAmount, 0)
    End Sub

    Public Sub ExportCSV(Optional ByVal ExtraFileName As String = "")
        Dim ExportData As String = """id"";""kilometers"";""fulldistance"";""fuelamount"";""priceamount"";""priceperliter"";""consumptionper100"";""distanceperfuelunit"";""timeprint"";""timediff"""
        For I = FuelList.Length - 1 To 0 Step -1
            With FuelList(I)
                ExportData &= vbNewLine
                ExportData &= """" & .ID & """;"
                ExportData &= """" & .KiloMeters & """;"
                ExportData &= """" & .DistanceState & """;"
                ExportData &= """" & .FuelAmount & """;"
                ExportData &= """" & .PriceAmount & """;"
                ExportData &= """" & .PricePerLiter & """;"
                ExportData &= """" & .ConsumptionPer100 & """;"
                ExportData &= """" & .MilesPerGallon & """;"
                ExportData &= """" & .TimePrint & """;"
                ExportData &= """" & .TimeDiff & """"
            End With
        Next
        SaveFile(AppPath & "\export.csv" & ExtraFileName, ExportData)
    End Sub

    Public Sub LoadCSV()
        Dim CSVData As New Data.DataSet
        Dim CSVReader As New OpenNETCF.Data.Text.TextDataAdapter(AppPath & "\export.csv", True, ";")
        CSVReader.Fill(CSVData)
        Dim CSVTable As Data.DataTable = CSVData.Tables(0)

        Dim answerPromt As MsgBoxResult
        answerPromt = MsgBox("Do you want to delete the existing data?", MsgBoxStyle.YesNoCancel, "Overwrite")
        If answerPromt = MsgBoxResult.Yes Then
            answerPromt = MsgBox("CSV data will replace(remove!) exisiting data (Old data is backupped as ""export.csv.importbackup"" in the SciLor's Fuel Blaster directory)", MsgBoxStyle.OkCancel, "Old data will be deleted!")
            If answerPromt = MsgBoxResult.Ok Then
                ExportCSV(".importbackup")
                System.IO.File.Copy(AppPath & "\FuelData.sdf.clean", DataPath, True)
            End If
        ElseIf answerPromt = MsgBoxResult.No Then
            answerPromt = MsgBox("CSV data will be added to the exisiting data", MsgBoxStyle.OkCancel, "Data will be added")
        End If
        If answerPromt = MsgBoxResult.Cancel Then
            MsgBox("You have successfully canceled the import!", MsgBoxStyle.Information, "Canceled")
            Exit Sub
        End If
        MsgBox("Import starts now", MsgBoxStyle.OkOnly, "Import")

        'Display Data
        Dim CSVFuel As FuelData
        Dim I As Integer = 0
        For Each row As Data.DataRow In CSVTable.Rows
            With CSVFuel
                '.ID = row(CSVTable.Columns("id"))
                .KiloMeters = row(CSVTable.Columns("kilometers"))
                .FuelAmount = row(CSVTable.Columns("fuelamount"))
                .PriceAmount = row(CSVTable.Columns("priceamount"))
                .PricePerLiter = row(CSVTable.Columns("priceperliter"))
                '.ConsumptionPer100 = row(CSVTable.Columns("consumptionper100"))
                '.MilesPerGallon = row(CSVTable.Columns("distanceperfuelunit"))
                .TimePrint = row(CSVTable.Columns("timeprint"))
                '.TimePrint = row(CSVTable.Columns("timediff"))

                Call AddFuelData(.KiloMeters, .FuelAmount, .PriceAmount, .PricePerLiter, True, .TimePrint)
                'Dim ExportData As String = """id"";""kilometers"";""fulldistance"";""fuelamount"";""priceamount"";""priceperliter"";""consumptionper100"";""distanceperfuelunit"";""timeprint"";""timediff"""
            End With
        Next
        Call SelectFuelData()
        Call frmFuel.ChangeLocation(MenuLoc.All)
        NeedRedraw = True
    End Sub

End Module
