﻿Imports System.Diagnostics

Module mdlStartUp
    Public Sub Main(ByVal args As String())
        CurrentCarFilePrefix = ""
        If args.Length = 0 Then
            AppPath = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase)
            If AppPath.StartsWith("file:\") Then
                AppPath = AppPath.Substring(6)
            End If
            CurrentCarFilePrefix = FuelBlasterSelect.frmSelect.GetDefault(AppPath)
        End If
        If args.Length = 1 Then
            CurrentCarFilePrefix = args(0)
        End If
        If Not CurrentCarFilePrefix = "" Then frmFuel.Text = CurrentCarFilePrefix + " " + frmFuel.Text
        Application.Run(frmFuel)
    End Sub

    Public Sub StartUp()
        'Get the Startup Path
        AppPath = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase)
        If AppPath.StartsWith("file:\") Then
            AppPath = AppPath.Substring(6)
            frmFuel.Font = New Font(frmFuel.Font.Name, frmFuel.Font.Size + 8, frmFuel.Font.Style)
            frmFuel.Height = 640
            frmFuel.Width = 480
            NeedRedraw = True
            'MsgBox(AppPath)
        End If

        Call SetUpConfig()
        Call LoadConfig()

        frmFuel.Font = New Font(frmFuel.Font.Name, Config(MyConfig.FontSize), frmFuel.Font.Style)

        Call PreDrawIcons()

        DataPath = AppPath & "\" + CurrentCarFilePrefix + "FuelDataV0911.sdf"

        If System.IO.File.Exists(AppPath & "\FuelData.sdf") = True And System.IO.File.Exists(DataPath) = False Then
            System.IO.File.Copy(AppPath & "\FuelData.sdf", DataPath, False)
            System.IO.File.Move(AppPath & "\FuelData.sdf", AppPath & "\FuelData.sdf.old")
        End If

        If System.IO.File.Exists(DataPath) = False Then
            System.IO.File.Copy(AppPath & "\FuelData.sdf.clean", DataPath, False)
        End If

        For I = 0 To 4
            ShowGraph(I) = True
        Next
        For I = 0 To 5
            ObjectHeight(I) = 10
            ItemMax(I) = 0
        Next

        Call CreateBackBuffer()

        IconText(MenuLoc.Stats) = "Statistics"
        IconText(MenuLoc.Graph) = "Graphs"
        IconText(MenuLoc.All) = "List"
        IconText(MenuLoc.Add) = "Add"
        IconText(MenuLoc.Config) = "Config"
        IconText(MenuLoc.About) = "Help/About"
        IconText(MenuLoc.EndMenu) = "Exit"

        For I = 0 To MenuLoc.EndMenu
            IconTextSize(I) = BackBuffer.MeasureString(IconText(I), frmFuel.Font)
        Next

        tmrDirectX.Enabled = False
        tmrDirectX.Interval = 150
        AddHandler tmrDirectX.Tick, AddressOf tmrDirectX_Tick

        VisibleCountArray = New String(,) {{3, "3"}, {7, "7"}, {15, "15"}, {30, "30"}, {0, "All"}}
        ReDim VisibleCountSize(VisibleCountArray.Length - 1)
        For I = 0 To 4
            VisibleCountSize(I) = BackBuffer.MeasureString(VisibleCountArray(I, ConfigType.Text), frmFuel.Font)
        Next

        Dim GraphTypeName As String
        If Not Config(MyConfig.LastGraphType) = ConfigShow(MyConfig.LastGraphType, 1, ConfigType.Value) Then
            GraphTypeName = Config(MyConfig.FuelAmountUnit) & ".p.100"
        Else
            GraphTypeName = Config(MyConfig.MetricsUnit) & ".p." & Config(MyConfig.FuelAmountUnit)
        End If
        VisibleGraphArray = New String() {Config(MyConfig.MetricsUnit), Config(MyConfig.FuelAmountUnit), Config(MyConfig.CurrencyUnit) & ".p." & Config(MyConfig.FuelAmountUnit), "Days", GraphTypeName}
        ReDim VisibleGraphSize(VisibleGraphArray.Length - 1)
        For I = 0 To 4
            VisibleGraphSize(I) = BackBuffer.MeasureString(VisibleGraphArray(I), frmFuel.Font)
        Next

        FontLineHeight = BackBuffer.MeasureString(vbNewLine & vbNewLine & vbNewLine & vbNewLine, frmFuel.Font).Height / 4

        'ObjectHeight(MenuLoc.All) = 1.1 * BackBuffer.MeasureString(vbNewLine & vbNewLine & vbNewLine & vbNewLine & vbNewLine & vbNewLine, frmFuel.Font).Height
        ConstTempString = "Distance: " & vbNewLine & _
             "Fuel: " & vbNewLine & _
             "Price: " & vbNewLine & _
             "Price p." & Config(MyConfig.FuelAmountUnit) & ": " & vbNewLine & _
             Config(MyConfig.FuelAmountUnit) & "/100" & Config(MyConfig.MetricsUnit) & ": " & vbNewLine & _
             Config(MyConfig.MetricsUnit) & "/" & Config(MyConfig.FuelAmountUnit) & ": " & vbNewLine & _
             "DateTime: "

        ConstTempSize = BackBuffer.MeasureString(ConstTempString, frmFuel.Font)
        ObjectHeight(MenuLoc.All) = ConstTempSize.Height + BlackDrawingPen.Width * 8 * Config(MyConfig.ScreenMultiplicator)


        StatText = _
                    "Distance" & vbNewLine & vbNewLine & _
                    "Fuel" & vbNewLine & vbNewLine & _
                    "Price" & vbNewLine & vbNewLine & _
                    "Price p." & Config(MyConfig.FuelAmountUnit) & vbNewLine & vbNewLine & _
                    Config(MyConfig.FuelAmountUnit) & "/100" & Config(MyConfig.MetricsUnit) & vbNewLine & vbNewLine & _
                    Config(MyConfig.MetricsUnit) & "/" & Config(MyConfig.FuelAmountUnit) & vbNewLine & vbNewLine & _
                    "Endur." & vbNewLine & vbNewLine & _
                    Config(MyConfig.MetricsUnit) & " left" & vbNewLine & vbNewLine & _
                    Config(MyConfig.FuelAmountUnit) & " left" & vbNewLine & vbNewLine & _
                    "d left" & vbNewLine & " "

        StatTextSize = BackBuffer.MeasureString(vbNewLine & vbNewLine & StatText & vbNewLine & vbNewLine & vbNewLine, frmFuel.Font)
        ObjectHeight(MenuLoc.Stats) = StatTextSize.Height - FontLineHeight / 2

        ObjectHeight(MenuLoc.Add) = FontLineHeight * 7 + Config(MyConfig.ScreenMultiplicator) * 4
        ItemMax(MenuLoc.Add) = 4
        For I = 0 To 9
            NumberSize(I) = BackBuffer.MeasureString(I, frmFuel.Font)
        Next
        NumberFieldSize = BackBuffer.MeasureString("0000" & vbNewLine & "0000", frmFuel.Font)


        For I = 0 To MyConfig.EndConfig - 1
            For J = 0 To ConfigMax(I)
                ConfigShowSize(I, J, ConfigType.Text) = BackBuffer.MeasureString(ConfigShow(I, J, ConfigType.Text), frmFuel.Font)
            Next
            ConfigNameSize(I) = BackBuffer.MeasureString(ConfigName(I), frmFuel.Font)
        Next
        ItemMax(MenuLoc.Config) = MyConfig.EndConfig + 1
        ObjectHeight(MenuLoc.Config) = FontLineHeight * 5.5

        isStartUp = True
        Call SelectFuelData()
        frmFuel.tmrDraw.Enabled = True
        Call frmFuel.pctDraw_Resize(New Object, New System.EventArgs)
    End Sub
End Module
