﻿Public Module mdlStructVars
    Public Structure FuelData
        Dim ID As Integer
        Dim DistanceState As Double
        Dim KiloMeters As Double
        Dim FuelAmount As Double
        Dim PriceAmount As Double
        Dim PricePerLiter As Double
        Dim ConsumptionPer100 As Double
        Dim MilesPerGallon As Double
        Dim TimePrint As String
        Dim TimeDiff As Double
    End Structure

    Public Structure FuelStats
        Dim All As AllStats
        Dim Average As AverageStats
        Dim MinMax As MinMax
    End Structure

    Public Structure AverageStats
        Dim KiloMeters As Double
        Dim FuelAmount As Double
        Dim PriceAmount As Double

        Dim PricePerLiter As Double
        Dim ConsumptionPer100 As Double
        Dim MilesPerGallon As Double

        Dim TimeDiff As Double

        Dim LeftKiloMeters As Double
        Dim LeftFuelAmount As Double
        Dim LeftTimeLength As Double
    End Structure

    Public Structure AllStats
        Dim DistanceState As Double

        Dim KiloMeters As Double
        Dim FuelAmount As Double
        Dim PriceAmount As Double

        Dim TimeLength As Double
    End Structure

    Public Structure MinMax
        Dim Min As AverageStats
        Dim Max As AverageStats
    End Structure

    Public Structure MyAddStats
        Dim KiloMeters As Double
        Dim FuelAmount As Double
        Dim PricePerLiter As Double
    End Structure

    Public Enum MenuLoc As Byte
        Stats = 0
        Graph = 1
        All = 2
        Add = 3
        Config = 4
        About = 5
        EndMenu = 6
    End Enum

    Public Enum ScreenSizeMulti As Byte
        QVGA = 1
        VGA = 2
    End Enum

    Public Enum MyConfig
        DistanceAddType = 0
        DistanceStart = 1

        CurrencyUnit = 2
        MetricsUnit = 3
        FuelAmountUnit = 4

        LastGraphType = 5

        ForegroundColor = 6
        BackgroundColor = 7

        FontSize = 8
        ScreenMultiplicator = 9
        IconSet = 10

        TapTime = 11

        EndConfig = 12
    End Enum

    Public Enum ConfigType As Byte
        Value = 0
        Text = 1
    End Enum

    Public Config(MyConfig.EndConfig - 1) As String
    Public ConfigCustom(MyConfig.EndConfig - 1) As String
    Public ConfigShow(MyConfig.EndConfig - 1, 8, 1) As String
    Public ConfigShowSize(MyConfig.EndConfig - 1, 8, 1) As SizeF
    Public ConfigSelected(MyConfig.EndConfig - 1) As Short
    Public ConfigName(MyConfig.EndConfig - 1) As String
    Public ConfigNameSize(MyConfig.EndConfig - 1) As SizeF
    Public ConfigMax(MyConfig.EndConfig - 1) As Byte

    Public CurrentCarFilePrefix As String = ""

    'Public Config(MyConfig.ScreenMultiplicator) As ScreenSizeMulti

    Public MaxGraphItems As Integer = 0
    Public VisibleGraphArray() As String
    Public VisibleCountArray(,) As String
    Public VisibleGraphSize() As SizeF
    Public VisibleCountSize() As SizeF

    Public AppPath As String
    Public DataPath As String
    Public ItemMax(MenuLoc.EndMenu) As Integer

    Public FuelList() As FuelData
    Public Stats As FuelStats
    Public AddStats As MyAddStats
    Public Stepping As Double
    Public TripFix As Integer = 1

    Public LastClickedItem As Integer = -1
    Public LastClickedTime As Long

    Public OverViewItemCount As Byte = 5
    Public OverViewBufferCount As Byte = 2
    Public OverViewPage As Byte = 0

    Public NumberSpan(,) As Byte = {{0, 5}, {1, 5}, {2, 6}}
    Public AddNumbers(2, 6) As Byte
    Public ArrowCountPerLine As Integer
    Public NumberSize(9) As SizeF
    Public NumberFieldSize As SizeF

    Public Version As String = "0.9.1.4"

    Public AddTimePrint As DateTime

    Public ShowGraph(4) As Boolean

    Public isStartUp As Boolean = False

    Public MenuItemCount As Byte = MenuLoc.EndMenu + 1

    Public CurrentLocation As MenuLoc = MenuLoc.Stats
    Public LastLocation As MenuLoc = MenuLoc.Stats

    Public FontLineHeight As Single

    Public StatTextSize As SizeF
    Public StatText As String

    Public IconText(MenuLoc.EndMenu) As String
    Public IconTextSize(MenuLoc.EndMenu) As SizeF

    Public MenuSelectNoMove As Boolean = False

    Public AboutTextComplete As String = _
    "SciLor's$" & vbNewLine & _
    "Fuel Blaster v" & Version & "$" & vbNewLine & _
    "~~~~" & vbNewLine & _
    "C:\>&he~l~p~~~" & vbNewLine & _
    "$" & vbNewLine & _
    "~Fuel Blaster Help..." & vbNewLine & _
    "~-With ""Double Taps"" you" & vbNewLine & _
    "~ $can click on special objects" & vbNewLine & _
    "~  $+Statistics: Refresh" & vbNewLine & _
    "~  $+List: Delete Entry" & vbNewLine & _
    "~  $+Config: Edit Custom Entry" & vbNewLine & _
    "~  $+Config: Save" & vbNewLine & _
    "~  $+Config: Import/Export" & vbNewLine & _
    "~  $+Add: Save" & vbNewLine & _
    "~  $+Help/About: Pause" & vbNewLine & _
    "$~~~~" & vbNewLine & _
    "------------------------------------------------------------$" & vbNewLine & _
    "$" & vbNewLine & _
    "C:\>&d~ir~~~" & vbNewLine & _
    "Directory of C:\.$" & vbNewLine & _
    "~.      " & "" & "<DIR>" & "     " & "&14-04-1991$" & vbNewLine & _
    "~..     " & "" & "<DIR>" & "     " & "&27-07-1990$" & vbNewLine & _
    "~Doom   " & "" & "<DIR>" & "     " & "&10-12-1993$" & vbNewLine & _
    "~Duke3D " & "" & "<DIR>" & "     " & "&29-01-1997$" & vbNewLine & _
    " " & vbNewLine & _
    "~0 File(s)" & " " & "0 Bytes.$~" & vbNewLine & _
    "~2 Dir(s)" & "  " & "200,900 Bytes free.$" & vbNewLine & _
    "$" & vbNewLine & _
    "C:\>&~~a:~~" & vbNewLine & _
    "$" & vbNewLine & _
    "A:\>&~~spe~cia~l-than~~ks~~~~" & vbNewLine & _
    "~Special Thanks to:" & vbNewLine & _
    "~G. Brizgys: Icon-Pack" & vbNewLine & _
    "" & vbNewLine & _
    "$" & vbNewLine & _
    "A:\>&~~loa~d-k~aiser~-d~rivers~~~~~" & vbNewLine & _
    "~NO &~DRIVERS &~THERE&..." & vbNewLine & _
    "~Error /()§%[8)=?&~§/%§=§%?`?*'ÄÖÜ:_%?&~`?*²³]}³³[_" & vbNewLine & _
    " " & vbNewLine & _
    "~Hello World!$~~~" & vbNewLine & _
    "$" & vbNewLine & _
    "~PLEASE DONATE$" & vbNewLine & _
    "~If you like this Software!$" & vbNewLine & _
    "~PAYPAL: $donation@scilor.com~~" & vbNewLine & _
    "~Subject: $~" & vbNewLine & _
    "~Fuel Blaster Donation~~~~~~~" & vbNewLine & _
    "$" & vbNewLine & _
    "A:\>&~~c:" & vbNewLine & _
    " " & vbNewLine & _
    "C:\>&~~cd Do~om" & vbNewLine & _
    "$" & vbNewLine & _
    "C:\Doom>&~~d~oom" & vbNewLine & _
    "~$~" & vbNewLine & _
    "~Loading&~.~.~.~~.~~.~~~.~~~.~~~~.~~~~~.~~~~~.~~~~~~.~~~~~~~.~~~~~~~.~~~~~" & vbNewLine & _
    "~Error&~~ Drivers missing!&~" & vbNewLine & _
    "~ Closing&~.~.~.~~" & vbNewLine & _
    "$" & vbNewLine & _
    "C:\Doom>&~~a:~~" & vbNewLine & _
    "$" & vbNewLine & _
    "A:\>&~~donate~~~~~" & vbNewLine & _
    "$" & vbNewLine & _
    "~PLEASE DONATE$" & vbNewLine & _
    "~If you like this Software!$" & vbNewLine & _
    "~PAYPAL: $donation@scilor.com~~" & vbNewLine & _
    "~Subject: $~" & vbNewLine & _
    "~Fuel Blaster Donation~~~~~~~" & vbNewLine & _
    "$" & vbNewLine & _
    "~Thank you for Watching!~~" & vbNewLine & _
    "$" & vbNewLine & _
    "$" & vbNewLine & _
    "                 i.$" & vbNewLine & _
    "                .7.$" & vbNewLine & _
    "               .. :v$" & vbNewLine & _
    "              c:  .X$" & vbNewLine & _
    "               i.::$" & vbNewLine & _
    "                 :$" & vbNewLine & _
    "               ..i..$" & vbNewLine & _
    "              #MMMMM$" & vbNewLine & _
    "              6M  AM$" & vbNewLine & _
    "              OM  tMMMM;$" & vbNewLine & _
    "           .X#MM  ;MMMMMMv$" & vbNewLine & _
    "       cEMMMMMMMU7@MMMMMMM@$" & vbNewLine & _
    "     MM@@#$BWB#@@#$WQWB#@MM.$" & vbNewLine & _
    "     MM                  ;M.$" & vbNewLine & _
    "     WMO€@@@@@@@@@@@@@@#OMM$" & vbNewLine & _
    "     QM  Another Cake by tM$" & vbNewLine & _
    "     MM       SciLor    oMM$" & vbNewLine & _
    "     6MMMMMMMMMMMMMMMMMMMMM$" & vbNewLine & _
    "     @M ................ WM$" & vbNewLine & _
    "     .A8OQWWWWWWWWWWWWWOAz2$" & vbNewLine & _
    "~.~.~.~~.~~.~~~.~~~.~~~~.~~~~~.~~~~~~.~~~~~~~."

    Public AboutText As String = AboutTextComplete


End Module
