﻿Imports System.IO

Public Class frmSelect

    Private BaseName As String = "FuelDataV0911.sdf"
    Private BaseNameConfig As String = "configV09.cfg"
    Private Shared DefaultName As String = "Default"
    Private AppPath As String

    Public Shared Function GetDefault(ByVal AppPath As String)
        Dim objStreamReader As StreamReader
        If System.IO.File.Exists(AppPath & "\" & DefaultName) Then
            objStreamReader = New StreamReader(AppPath & "\" & DefaultName)
            Try
                Return objStreamReader.ReadLine
            Catch ex As Exception
            End Try
        End If
        Return ""
    End Function

    Public Shared Sub SetDefault(ByVal name As String, ByVal AppPath As String)
        Dim objFileStream As FileStream
        Dim objStreamWriter As StreamWriter

        objFileStream = New FileStream(AppPath & "\" & DefaultName, FileMode.Create, FileAccess.Write)
        objStreamWriter = New StreamWriter(objFileStream, System.Text.Encoding.Default)
        objStreamWriter.WriteLine(name)

        objStreamWriter.Close()
        objFileStream.Close()
    End Sub

    Private Sub frmSelect_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        AppPath = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase)
        If AppPath.StartsWith("file:\") Then
            AppPath = AppPath.Substring(6)
        End If

        Dim files As FileInfo() = New DirectoryInfo(AppPath).GetFiles("*" & BaseName)
        For Each File As FileInfo In files
            Dim Name As String = File.Name
            lstList.Items.Add(Name.Replace(BaseName, ""))
        Next
    End Sub

    Private Sub mnuRemove_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuRemove.Click
        If lstList.SelectedIndex < 0 Then
            Return
        End If

        If MsgBox("Are you sure you want to delete " & "" & "?", MsgBoxStyle.YesNo, "Sure?") = MsgBoxResult.Yes Then
            Try
                File.Delete(AppPath & "\" & lstList.SelectedItem & BaseName)
                Call lstList.Items.Clear()
                Call frmSelect_Load(Nothing, Nothing)
            Catch ex As Exception
                MsgBox(ex.Message, MsgBoxStyle.Critical, "Error")
            End Try
        End If
    End Sub

    Private Sub mnuAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuAdd.Click
        Dim Name As String = InputBox("Please enter a name", "New Entry")
        If lstList.Items.Contains(Name) Then
            MsgBox(Name & " " & "already exists", MsgBoxStyle.Critical, "Problem")
            Return
        End If
        Try
            File.Copy(AppPath & "\" & "FuelData.sdf" & ".clean", AppPath & "\" & Name & BaseName)

            Call lstList.Items.Clear()
            Call frmSelect_Load(Nothing, Nothing)
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Critical, "Error")
        End Try
    End Sub

    Private Sub mnuRun_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuRun.Click
        If lstList.SelectedIndex < 0 Then
            Return
        End If
        Process.Start(AppPath & "\SciLor's Fuel Blaster.exe", lstList.SelectedItem)
        Application.Exit()
    End Sub

    Private Sub mnuRename_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuRename.Click
        If lstList.SelectedIndex < 0 Then
            Return
        End If
        Try
            Dim Name As String = InputBox("Enter a new name", "Rename", lstList.SelectedItem)

            File.Move(AppPath & "\" & lstList.SelectedItem & BaseName, _
                      AppPath & "\" & Name & BaseName)
            Try
                File.Move(AppPath & "\" & lstList.SelectedItem & BaseNameConfig, _
                          AppPath & "\" & Name & BaseNameConfig)
            Catch ex As Exception
            End Try
            Call lstList.Items.Clear()
            Call frmSelect_Load(Nothing, Nothing)
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Critical, "Error")
        End Try
    End Sub

    Private Sub mnuSetDefault_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuSetDefault.Click
        If lstList.SelectedIndex < 0 Then
            Return
        End If
        SetDefault(lstList.SelectedItem, AppPath)
        MsgBox("Default entry is: " & GetDefault(AppPath))
    End Sub
End Class
